Most binary files become corrupted when downloading from CVS repository browser when Redmine

is running on a Windows server
Status: Closed Start date: 2010-08-09

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 1.1.2   

Resolution: Fixed Affected version: 1.1.1

Description

Most binary files become corrupted when downloading from CVS repository browser when Redmine is running on a Windows server.

The corruption is 100% repeatable.

The patch is a one character change at source:trunk/lib/redmine/scm/adapters/abstract_adapter.rb#L191.

<             IO.popen(cmd, "r+") do |io|

----

>             IO.popen(cmd, "r+b") do |io|

 On Windows, without this change the pipe is opened in text mode and any 0x1A bytes are treated as EOF and subsequent bytes

already in the pipe are discarded.

Note: "r+b" is equivalent to "r+" on non-Windows platforms, so this patch should be harmless for all platforms.

Related issues:

Related to Redmine - Defect #2664: Mercurial: Repository path encoding of non... Closed 2009-02-04

Associated revisions

Revision 4815 - 2011-02-12 10:43 - Toshi MARUYAMA

scm: cvs: fix most binary files become corrupted on Windows (#6090).

History

#1 - 2011-02-05 13:56 - Toshi MARUYAMA

- Status changed from New to 7

- Assignee set to Toshi MARUYAMA

- Priority changed from High to Normal

#2 - 2011-02-07 12:02 - Toshi MARUYAMA

- Tracker changed from Patch to Defect

#3 - 2011-02-10 00:49 - Toshi MARUYAMA

- File cvs-cat-bin.diff added

Gareth, Could you try this patch?

And where can I download Windows CVS 1.12 binary?

#4 - 2011-02-10 09:46 - Gareth Sylvester-Bradley

Maruyama-san,

Gareth, Could you try this patch?

 Your patch works great on my system, thanks.

You probably spotted that my original patch was flawed, since some of the other calls to shellout() need to be opened using "r+" instead of "r+b";

since submitting my original one, I modified it locally to pass the mode as an argument with a default of "r+".

2025-07-01 1/2

https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/scm/adapters/abstract_adapter.rb#L191


Your solution is neater!

And where can I download Windows CVS 1.12 binary?

 My CVS servers are running CVS 1.11 (stable), although I'd like CVS 1.12 for the enhanced directory listing. At the moment, I'm relying on patch 

#4113.

My Redmine server seems to have very old CVSNT 2.5.03 client.

Links:

http://ftp.gnu.org/non-gnu/cvs/binary/stable/x86-woe/ (Windows CVS 1.11)

http://ftp.gnu.org/non-gnu/cvs/binary/feature/x86-woe/ (Windows CVS 1.12)

http://www.cvsnt.org/

Thanks,

Gareth

#5 - 2011-02-11 09:29 - Toshi MARUYAMA

- Target version set to 1.1.2

- Affected version (unused) set to 1.1.1

- Affected version set to 1.1.1

#6 - 2011-02-12 13:02 - Toshi MARUYAMA

- Status changed from 7 to Closed

- Resolution set to Fixed

I commited trunk r4815 and 1.1 stable r4818.

Thanks.

Files

cvs-cat-bin.diff 517 Bytes 2011-02-09 Toshi MARUYAMA
